#
#   5B - Network
#

from compat import set

class Network(object):
	#  node   set of Node

	def __init__(self, level):
		self.nodes = set()
		for part in level.parts:
			for i in xrange(part.num_terminals()):
				if not part.nodes[i]:
					node = Node()
					self.nodes.add(node)
					part.find_reachable_terminals(i, node)

	def dump(self):
		print "Network:"
		for node in self.nodes:
			print node,
			for t in node.terminals:
				print t,
			print
		
	def reset_nodes(self):
		for node in self.nodes:
			node.state = 0


class Node(object):
	#  terminals   set of (part, terminal_no)
	#  state       bits 0x1 = negative, 0x2 = positive
	
	next_serial = 1

	def __init__(self):
		self.serial = Node.next_serial
		Node.next_serial += 1
		self.terminals = set()

	def __repr__(self):
		return "Node#%s" % self.serial
	
	def __contains__(self, t):
		return t in self.terminals

	def add(self, t):
		self.terminals.add(t)
		part, i = t
		part.nodes[i] = self

	def set(self, state):
		if not state & self.state:
			self.state |= state
			for part, i in self.terminals:
				part.node_changed(i)
