#
#   5b - Parts Catalogue
#

class PartCatalogEntry(object):
	#  name
	#  constructor
	#  args
	
	def __init__(self, name, constructor, *args):
		self.name = name
		self.constructor = constructor
		self.args = args
	
	def instantiate(self):
		part = self.constructor()
		part.init_from_catalog(*self.args)
		return part


P = PartCatalogEntry

from selector import Selector
from uniselector import Uniselector
from distribution_frame import DistributionFrame
from junction import Junction
from battery_terminal import BatteryTerminal
from telephone import Telephone
from bomb import Bomb
from text import Text
from lightbulb import LightBulb

catalog = [
	P("Uniselector", Uniselector),
	P("Group Selector", Selector),
	P("Distribution Frame", DistributionFrame, 5),
	P("Junction", Junction),
	P("Battery +", BatteryTerminal, 1),
	P("Battery -", BatteryTerminal, 0),
	P("Light Bulb", LightBulb),
	P("Green Phone", Telephone, 0),
	P("Red Phone", Telephone, 1),
	P("Bomb", Bomb),
	P("Text", Text),
]
