#
#   5B - Battery terminal
#

from pygame import Rect
from part import Part
from albow.image_array import get_image_array

class BatteryTerminal(Part):\
	#  polarity   int   0 = negative, 1 = positive

	images = get_image_array("parts/battery_terminals.png", 2)
	terminal_points = [(0, 0)]
	
	size = images[0].get_size()
	
	def __init__(self):
		Part.__init__(self)
		self.off_hook = False
		self.dial_phase = 0
	
	def init_from_catalog(self, polarity):
		self.polarity = polarity
	
	def draw(self, surf, t):
		gc = t * self.position
		img = self.images[self.polarity]
		r = img.get_rect()
		r.center = gc.coords
		surf.blit(img, r)

	def get_params(self, params):
		params.append(self.polarity)

	def read_args(self, r):
		Part.read_args(self, r)
		self.polarity = r.get_arg(int)

	def get_oriented_rect(self):
		r = Rect(((0, 0), self.size))
		r.center = (0, 0)
		return r

	def source(self):
		state = 1 << self.polarity
		self.set_node(0, state)
